package com.trade.client.trade.exportrebate.controller;

import com.trade.common.core.domain.ResponseResult;
import com.trade.common.core.page.GridPage;
import com.trade.service.trade.exportrebate.dto.ExportTaxRebateStatisticDto;
import com.trade.service.trade.exportrebate.dto.search.TaxRebateSearchDto;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.trade.client.trade.exportrebate.service.ExportTaxRebateService;

import javax.annotation.Resource;

/**
 * 出口退税接口
 *
 * @author hlb
 * @since 2024-10-22 15:46:16
 */
@Controller
@RequestMapping("/taxRebate")
public class ExportTaxRebateController {

    /**
     * 服务对象
     */
    @Resource
    private ExportTaxRebateService exportTaxRebateService;

    /**
     * 分页查询出口退税明细
     *
     * @param search 查询实体
     * @return 所有数据
     */
    @GetMapping("/pages")
    @ResponseBody
    public ResponseResult<GridPage<ExportTaxRebateStatisticDto>> getPages(TaxRebateSearchDto search) {
        return ResponseResult.success(exportTaxRebateService.getPagesBySearch(search));
    }

    /**
     * 重定向小图进行退税
     */
    @GetMapping("/doTaxRebate")
    public String doTaxRebate() {
        String taxRebateUrl = exportTaxRebateService.getTaxRebateUrl();
        return "redirect:" + taxRebateUrl;
    }
}
