package com.trade.service.trade.salesorder.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.github.pagehelper.PageInfo;
import com.trade.service.trade.salesorder.domain.SalesOrder;
import com.trade.service.trade.salesorder.vo.SalesOrder4CustomsDeclarationVO;
import com.trade.service.trade.salesorder.vo.SalesOrderDtlVO;
import com.trade.service.trade.salesorder.vo.SalesOrderSearch;
import com.trade.service.trade.salesorder.vo.SalesOrderVO;

import java.util.List;

/**
 * <p>
 * 销售订单表 服务类
 * </p>
 *
 * @author zhangchenm
 * @since 2024-09-06
 */
public interface ISalesOrderService extends IService<SalesOrder> {

    PageInfo<SalesOrderVO> queryListBySearch(SalesOrderSearch search);

    SalesOrderDtlVO getDetail(Long id, boolean is4Update);

    Long saveSalesOrder(SalesOrder salesOrder);

    boolean existSalesOrderByImporterId(Long importerId);

    /**
     * 查询订单号列表，用于拉取报关单
     * 
     * @return 订单号列表
     */
    List<SalesOrder4CustomsDeclarationVO> queryOrderNo4GetCustomsDeclaration();

    /**
     * 根据订单号更新报关单状态为已完成
     */
    void updateCustomsDeclarationStatusFinishedByOrderNo(String orderNo);

    /**
     * 根据订单号查询订单
     * 
     * @param orderNo 订单号
     * @return 订单
     */
    SalesOrder getByOrderNo(String orderNo);

    /**
     * 根据销售合同ID查询订单
     * 
     * @param saleContractId 销售合同ID
     * @return 订单列表
     */
    List<SalesOrder> queryBySaleContractId(Long saleContractId);
}
